# When run will fully give a random power to a player.
function osp:api/reset_superpower

execute if score Eldritch osp.RarityCount < EldritchLimit osp.settings run function osp:systems/randomizer/selection/eldritch

tag @s remove Selected

## Power Tracking
function #osp:gain_superpower

## Effects
## Elderitch
execute if entity @s[tag=osp.rarity.eldritch] run particle minecraft:totem_of_undying ~ ~ ~ 0 0 0 1 1000
execute if entity @s[tag=osp.rarity.eldritch] run particle minecraft:explosion_emitter ~ ~ ~
execute if entity @s[tag=osp.rarity.eldritch] run playsound minecraft:entity.wither.spawn master @a ~ ~ ~ 0.25 0 0.25

execute if entity @s[tag=osp.rarity.eldritch] run execute if predicate osp:randomizer/50 run tag @s add A

execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=A] if predicate osp:randomizer/50 run tag @s add AA
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=A,tag=!AA] run tag @s add AB


execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=!A] if predicate osp:randomizer/50 run tag @s add BA
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=!A,tag=!BA] run tag @s add BB

execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=AA] run tellraw @s ["",{"text":"You have gained a "},{"text":"El","color":"dark_purple"},{"text":"d","obfuscated":true,"color":"dark_purple"},{"text":"rit","color":"dark_purple"},{"text":"c","obfuscated":true,"color":"dark_purple"},{"text":"h","color":"dark_purple"},{"text":" superpower!"}]
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=AB] run tellraw @s ["",{"text":"You have gained a "},{"text":"E","color":"dark_purple"},{"text":"ldritch","obfuscated":true,"color":"dark_purple"},{"text":" superpower!"}]
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=BA] run tellraw @s ["",{"text":"You have gained a "},{"text":"E","color":"dark_purple"},{"text":"ld","obfuscated":true,"color":"dark_purple"},{"text":"r","color":"dark_purple"},{"text":"i","obfuscated":true,"color":"dark_purple"},{"text":"tch","color":"dark_purple"},{"text":" superpower!"}]
execute if entity @s[tag=osp.rarity.eldritch] run execute if entity @s[tag=BB] run tellraw @s ["",{"text":"You have gained a "},{"text":"E","color":"dark_purple"},{"text":"l","obfuscated":true,"color":"dark_purple"},{"text":"dr","color":"dark_purple"},{"text":"i","obfuscated":true,"color":"dark_purple"},{"text":"t","color":"dark_purple"},{"text":"c","obfuscated":true,"color":"dark_purple"},{"text":"h","color":"dark_purple"},{"text":" superpower!"}]

tag @s remove A
tag @s remove AA
tag @s remove AB
tag @s remove BA
tag @s remove BB

# function run test
execute if score #TestStart function_run_count matches 0.. run scoreboard players add osp:systems/randomizer/eldritch function_run_count 1
