execute if score #TestStart function_run_count matches 0.. run scoreboard players add osp:loops/player function_run_count 1

## Powersmith
execute if entity @s[tag=!osp.powersmith.GivePower] run scoreboard players reset @s GivePower
execute if entity @s[tag=!osp.powersmith.GivePower] run scoreboard players reset @s osp.GivePower
execute if entity @s[tag=osp.powersmith.GivePower] run scoreboard players enable @s GivePower

execute if entity @s[tag=osp.powersmith.GivePower] run scoreboard players add @s osp.GivePower 1
execute if entity @s[tag=osp.powersmith.GivePower] if score @s osp.GivePower matches 300.. run tellraw @s {"text":"[The request has timed out]","color":"gold"}
execute if entity @s[tag=osp.powersmith.GivePower] if score @s osp.GivePower matches 300.. run tag @s remove osp.powersmith.GivePower
execute if score @s GivePower matches 1.. run function osp:powers/powersmith/give_power

## Shadow
execute if entity @s[tag=osp.powers.shadowy_physique] run function osp:powers/shadowy_physique/loop

## Start
execute if score 60tick osp.settings matches 0 run power grant @s osp:all osp:osp
scoreboard players reset @s[gamemode=!creative] powerID
execute if entity @s[gamemode=creative] run scoreboard players enable @s powerID

## Elder Timer
execute if score @s osp.ElderTimer matches ..0 run scoreboard players set @s osp.ElderTimer 0

## Sculk King
execute if entity @s[tag=osp.powers.sculk_king] run function osp:powers/sculk_king/loop

execute if entity @s[tag=osp.sculk_king.friend] unless score @s osp.sculkID = G osp.sculkID run function osp:powers/sculk_king/player_infection/sculk_king_go

scoreboard players reset @s[tag=!osp.powers.sculk_king] InfectionInfo
scoreboard players enable @s[tag=osp.powers.sculk_king] InfectionInfo
execute if score @s InfectionInfo matches 1.. run function osp:powers/sculk_king/player_infection/trigger

scoreboard players reset @s[tag=!osp.powers.sculk_king] MakeAllie
scoreboard players enable @s[tag=osp.powers.sculk_king] MakeAllie
execute if score @s MakeAllie matches 1.. run function osp:powers/sculk_king/player_infection/freind

scoreboard players reset @s[tag=!osp.powers.sculk_king] Punish
scoreboard players enable @s[tag=osp.powers.sculk_king] Punish
execute if score @s Punish matches 1.. run function osp:powers/sculk_king/player_infection/punish

execute if score @s Respond matches 1.. run function osp:powers/sculk_king/player_infection/freindrequest

## Energy infusion
execute if entity @s[tag=osp.powers.energy-infusion] run function osp:powers/energy-infusion/loop
execute if score 60tick osp.settings matches 0 if data entity @s Inventory[{Slot: 103b}].tag.energy-infusion.water_breathing run effect give @s water_breathing 5 0 true
execute if score 60tick osp.settings matches 3 if data entity @s Inventory[{Slot: 103b}].tag.energy-infusion.conduit_power run effect give @s conduit_power 5 0 true
execute if score 60tick osp.settings matches 6 if data entity @s Inventory[{Slot: 101b}].tag.energy-infusion.dolphins_grace run effect give @s dolphins_grace 5 2 true
execute if score 60tick osp.settings matches 8 if data entity @s Inventory[{Slot: 100b}].tag.energy-infusion.jump_boots run effect give @s jump_boost 5 1 true
execute if score 60tick osp.settings matches 12 if data entity @s Inventory[{Slot: -106b}].tag.energy-infusion.totem_regen run effect give @s regeneration 5 2 true
execute if score 60tick osp.settings matches 15 if data entity @s SelectedItem.tag.energy-infusion.totem_regen run effect give @s regeneration 5 2 true
execute if data entity @s Inventory[{Slot: -106b}].tag.energy-infusion.0grav run execute as @e[type=#addition:arrows,distance=..3,tag=!osp.NoGrav] run tag @s add osp.NoGrav
execute if data entity @s SelectedItem.tag.energy-infusion.0grav run execute as @e[type=#addition:arrows,distance=..3,tag=!osp.NoGrav] run tag @s add osp.NoGrav

# Haste
execute if score 60tick osp.settings matches 0 store result score LevelM num run data get entity @s SelectedItem.tag.energy-infusion.haste
execute if score 60tick osp.settings matches 0 store result score LevelO num run data get entity @s Inventory[{Slot: -106b}].tag.energy-infusion.haste
execute if score 60tick osp.settings matches 0 if score LevelM num >= LevelO num run scoreboard players operation Level num = LevelM num
execute if score 60tick osp.settings matches 0 if score LevelM num < LevelO num run scoreboard players operation Level num = LevelO num

execute if score 60tick osp.settings matches 0 if score Level num matches 1 run effect give @s haste 5 0 true
execute if score 60tick osp.settings matches 0 if score Level num matches 2 run effect give @s haste 5 1 true
execute if score 60tick osp.settings matches 0 if score Level num matches 3 run effect give @s haste 5 2 true
execute if score 60tick osp.settings matches 0 if score Level num matches 4 run effect give @s haste 5 3 true
execute if score 60tick osp.settings matches 0 if score Level num matches 5 run effect give @s haste 5 4 true
execute if score 60tick osp.settings matches 0 if score Level num matches 6 run effect give @s haste 5 5 true
execute if score 60tick osp.settings matches 0 if score Level num matches 7 run effect give @s haste 5 6 true
execute if score 60tick osp.settings matches 0 if score Level num matches 8 run effect give @s haste 5 7 true
execute if score 60tick osp.settings matches 0 if score Level num matches 9 run effect give @s haste 5 8 true
execute if score 60tick osp.settings matches 0 if score Level num matches 10 run effect give @s haste 5 9 true

# Add Charge
scoreboard players reset @s[gamemode=!creative] add_charge
execute if entity @s[gamemode=creative,tag=osp.powers.energy-infusion] run scoreboard players enable @s add_charge
execute if entity @s[gamemode=creative,tag=osp.powers.energy-infusion] unless score @s add_charge matches 0 run function osp:powers/energy-infusion/add_charge

## Nature Control
#execute if score @s SetWeather matches 1.. run function osp:powers/nature_control/weather
#scoreboard players reset @s[tag=!osp.powers.nature_control] SetWeather
#scoreboard players enable @s[tag=osp.powers.nature_control] SetWeather

execute if score @s ListBiomeItems matches 1.. run function osp:powers/nature_control/list_biome_items
scoreboard players reset @s[tag=!osp.powers.nature_control] ListBiomeItems
scoreboard players enable @s[tag=osp.powers.nature_control] ListBiomeItems

resource set @s[tag=osp.powers.nature_control,gamemode=creative] osp:eldritch/nature_control_summoncooldown 0

## Tracking
scoreboard players reset @s[tag=!osp.powers.clairvoyance] Clairvoyance
scoreboard players enable @s[tag=osp.powers.clairvoyance] Clairvoyance
execute if score @s Clairvoyance matches 1.. unless entity @s[tag=osp.PowerDisabled] run function osp:powers/clairvoyance/list

## space control

execute if entity @s[tag=osp.sprint] if score @s osp.Xkeymove matches -1 if score @s osp.Ykeymove matches 0 if score @s osp.Zkeymove matches 1 rotated ~-180 ~ rotated ~45 0 run function osp:powers/space_control/sprint/tp
execute if entity @s[tag=osp.sprint] run function osp:powers/space_control/sprint
#tellraw @s ["",{"score":{"name":"@s","objective":"osp.Xkeymove"}},{"text":"\n"},{"score":{"name":"@s","objective":"osp.Ykeymove"}},{"text":"\n"},{"score":{"name":"@s","objective":"osp.Zkeymove"}},{"text":"\n "}]

## OfflineTimer
execute if score @s osp.OfflineTimer matches 20.. run function osp:systems/reset_timer/cheak

## Player IDs and Player Markers
execute unless score @s osp.playerID matches -2147483648..214748364 run scoreboard players add G osp.playerID 1
execute unless score @s osp.playerID matches -2147483648..214748364 if score PowerWhenJoin osp.settings matches 1 run function osp:systems/randomizer/join
execute unless score @s osp.playerID matches -2147483648..214748364 run scoreboard players operation @s osp.playerID = G osp.playerID

scoreboard players enable @s Introduction
execute if score @s Introduction matches 1.. run tellraw @s ["",{"text":"Welcome to OSP!","color":"gold"},{"text":"\n"},{"text":"   ","italic":true,"color":"aqua"},{"text":"Planet Minecraft","italic":true,"color":"aqua","clickEvent":{"action":"open_url","value":"https://www.planetminecraft.com/data-pack/origins-superhero-overhaul-v1/"}},{"text":"\n   ","italic":true,"color":"aqua"},{"text":"Modrinth","italic":true,"color":"aqua","clickEvent":{"action":"open_url","value":"https://modrinth.com/datapack/origins-superpowers"}},{"text":"\n   ","italic":true,"color":"aqua"},{"text":"Origins Discord","italic":true,"color":"aqua","clickEvent":{"action":"open_url","value":"https://discord.gg/CXwWxgghvN"}},{"text":"("},{"text":"OSP on Origins Discord","italic":true,"color":"aqua","clickEvent":{"action":"open_url","value":"https://discord.com/channels/734127708488859831/1203425916794183721/1203425916794183721"}},{"text":")\n"},{"text":"   ","italic":true,"color":"aqua"},{"text":"OSP Discord","italic":true,"color":"aqua","clickEvent":{"action":"open_url","value":"https://discord.gg/92RtSxpEBK"}},{"text":"\n   ","italic":true,"color":"aqua"},{"text":"My Discord","italic":true,"color":"aqua","clickEvent":{"action":"open_url","value":"https://discord.gg/T3xwZDUd9Z"}}]
execute if score @s Introduction matches 1.. run origin gui @s osp:introduction
execute if score @s Introduction matches 1.. run scoreboard players reset @s Introduction

## Power Disabling
execute if score @s osp.powerdisabled matches 1.. if entity @s[tag=!osp.PowerDisabled] run function osp:api/disable
execute if score @s osp.powerdisabled matches 1.. run scoreboard players remove @s osp.powerdisabled 1
execute if score @s osp.powerdisabled matches 0 if entity @s[tag=osp.PowerDisabled] run function osp:api/enable

## Flashbang
execute if score @s[tag=osp.FlashBanged] osp.blind matches 1.. run function osp:powers/flash_bang/tick

## Orignal Werewolf
execute if entity @s[tag=osp.powers.werewolf] run scoreboard players enable @s WerewolfColor
execute unless entity @s[tag=osp.powers.werewolf] run scoreboard players reset @s WerewolfColor
execute if score @s WerewolfColor matches 1.. run function osp:powers/orignal_werewolf/werewolfcolor

execute if entity @s[tag=osp.orignal_werewolf.tf,tag=osp.powers.orignal_werewolf] run function osp:powers/orignal_werewolf/loop
execute if entity @s[tag=osp.orignal_werewolf.tf,tag=!osp.powers.orignal_werewolf] run function osp:powers/orignal_werewolf/lower_werewolf/loop

## Regeneration
execute if entity @s[tag=osp.regeneration.glow] run function osp:powers/regeneration/charge

## Rewind
execute if entity @s[tag=osp.powers.rewind,tag=!osp.rewind.rewind] run function osp:powers/rewind/save
execute if entity @s[tag=osp.powers.rewind,tag=osp.rewind.rewind] if data storage osp:rewind rewind[0] run function osp:powers/rewind/load
execute if score 5tick osp.settings matches 0 if entity @s[tag=osp.rewind.rewind] run tag @s remove osp.rewind.rewind

scoreboard players set @s osp.Xkeymove 0
scoreboard players set @s osp.Ykeymove 0
scoreboard players set @s osp.Zkeymove 0
