execute if score #TestStart function_run_count matches 0.. run scoreboard players add osp:powers/fire_manipulation/tick function_run_count 1


execute at @a if score @s osp.FlameID = @p osp.playerID run tag @p add self

## Visual
particle flame ~ ~ ~ 0.1 0.1 0.1 0 1 force @a
execute if entity @s[tag=osp.block] run particle smoke ~ ~ ~ 0.1 0.1 0.1 0 1 normal @a

execute if entity @s[tag=osp.block] as @e[type=#addition:arrows,distance=..1] run playsound entity.generic.burn player @a ~ ~ ~
execute if entity @s[tag=osp.block] as @e[type=#addition:arrows,distance=..1] run kill @s

## Motion
execute if score @s osp.FlameTimer matches ..50 if entity @s[tag=!osp.block] run tp @s ~ ~-0.05 ~

execute if entity @s[tag=osp.attack] run tp @s ^ ^ ^0.25

execute at @s as @e[dx=0,dy=0,dz=0] positioned ~-0.99 ~-0.99 ~-0.99 if entity @s[dx=0,dy=0,dz=0] run tag @s add osp.CatchFire
execute at @s as @e[dx=0,dy=0,dz=0] positioned ~-0.99 ~-0.99 ~-0.99 if entity @s[dx=0,dy=0,dz=0] run damage @s 3 in_fire by @p[tag=self]
execute at @s as @e[dx=0,dy=0,dz=0] positioned ~-0.99 ~-0.99 ~-0.99 if entity @s[dx=0,dy=0,dz=0] if biome ~ ~ ~ #osp:hot run damage @s 6 in_fire by @p[tag=self]

## End
tag @a[tag=self] remove self

# Destory when touch block
execute if block ~ ~ ~ air run setblock ~ ~ ~ fire

execute if block ~ ~ ~ water if predicate osp:randomizer/10 run tag @s add evap
execute if entity @s[tag=evap] run setblock ~ ~ ~ air
execute if entity @s[tag=evap] align xyz positioned ~0.5 ~0.5 ~0.5 run playsound minecraft:entity.generic.extinguish_fire block @a ~ ~ ~ 1 2
execute if entity @s[tag=evap] align xyz positioned ~0.5 ~0.5 ~0.5 run particle minecraft:large_smoke ~ ~ ~ 0.25 0.25 0.25 0 5
tag @s remove evap

execute if block ~ ~ ~ #osp:ice_fire run tag @s add evap
execute if entity @s[tag=evap] run setblock ~ ~ ~ water
execute if entity @s[tag=evap] align xyz positioned ~0.5 ~0.5 ~0.5 run playsound minecraft:entity.generic.extinguish_fire block @a ~ ~ ~ 1 2
execute if entity @s[tag=evap] align xyz positioned ~0.5 ~0.5 ~0.5 run particle minecraft:large_smoke ~ ~ ~ 0.25 0.25 0.25 0 5
tag @s remove evap

execute if block ~ ~ ~ water_cauldron run setblock ~ ~ ~ cauldron

execute if entity @e[type=marker,distance=..1,tag=osp.Water] run tag @s add go
execute if entity @s[tag=go] run playsound minecraft:entity.generic.extinguish_fire block @a ~ ~ ~ 1 2
execute if entity @s[tag=go] run particle minecraft:large_smoke ~ ~ ~ 0.25 0.25 0.25 0 5
execute if entity @s[tag=go] run kill @e[type=marker,distance=..1,tag=osp.Water,limit=1]
execute if entity @s[tag=go] run kill @s
tag @s remove go

execute if block ^ ^ ^0.25 #osp:flamable if block ~ ~ ~ #osp:replaceable run setblock ~ ~ ~ fire destroy
execute if block ^ ^ ^0.25 #osp:flamable if block ~ ~ ~ #osp:replaceable run kill @s

execute if block ~ ~ ~ #osp:solid run kill @s
execute if block ~ ~ ~ #addition:swater run kill @s
execute if block ~ ~ ~ #addition:water[waterlogged=true] run kill @s


# Timer
scoreboard players remove @s osp.FlameTimer 1
execute if score @s osp.FlameTimer matches ..0 run kill @s
